/* eslint-disable */
<template>
  <div class="posts">
    <h1>Posts</h1>
    <div v-if="posts.length > 0" class="table-wrap">
      <div>
        <router-link v-bind:to="{ name : 'NewPost' }" class="">Add Post</router-link>
      </div>
      <table>
        <thead>
        <td>Title</td>
        <td width="550">Description</td>
        <td>Author</td>
        <td>Image</td>
        <td width="100" align="center">Action</td>
        </thead>
        <tbody>
          <tr v-for="post in posts" v-bind:key="post.title">
            <td>{{ post.title }}</td>
            <td>{{ post.description }}</td>
            <td v-if="post.author">{{ post.author }}</td>
            <td v-if="!post.author">N/A</td>
            <td v-if="post.image"><a :href="post.image" target="_blank">View Image</a></td>
            <td v-if="!post.image">N/A</td>
            <td align="center">
              <router-link v-bind:to="{ name: 'EditPost', params: { id: post._id } }">Edit</router-link>
              <a href="javascript:void(0);" @click="deletePost(post._id)">Delete</a>
            </td>
          </tr>
        </tbody>
      </table>
    </div>
    <div v-else>
      There are no posts... Let's add some now <br><br>
      <router-link v-bind:to="{ name : 'NewPost' }" class="add_post_link">Add Post</router-link>
    </div>
  </div>
</template>
<script>
import PostsService from '@/services/PostsService'
export default {
  name: 'posts',
  data () {
    return {
      posts: []
    }
  },
  mounted () {
    this.getPosts()
  },
  methods: {
    async getPosts () {
      const response = await PostsService.fetchPosts()
      this.posts = response.data.posts
    },
    async deletePost (id) {
      await PostsService.deletePost(id)
      this.getPosts()
      this.$router.push({ name: 'Posts' })
    }
  }
}

</script>
<style type="text/css">
.table-wrap {
  width: 60%;
  margin: 0 auto;
  text-align: center;
}

table th,
table tr {
  text-align: left;
}

table thead {
  background: #4d7ef7;
}

table tr td {
  padding: 10px;
}

table tr:nth-child(odd) {
  background: #f2f2f2;
}

a {
  color: #4d7ef7;
  text-decoration: none;
}

a.add_post_link {
  background: #4d7ef7;
  color: #fff;
  padding: 10px 80px;
  text-transform: uppercase;
  font-size: 12px;
  font-weight: bold;
}

</style>
